'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _filterProps = require('./utils/filterProps');

var _filterProps2 = _interopRequireDefault(_filterProps);

var _htmlTags = require('./htmlTags');

var _htmlTags2 = _interopRequireDefault(_htmlTags);

var _ = require('./');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var ucfirst = function ucfirst(s) {
  return s.charAt(0).toUpperCase() + s.slice(1);
};

var anonCounter = 0;

var RecomposeRockeyHoc = function RecomposeRockeyHoc() {
  var displayName = null;
  var BaseComponent = null;

  // TODO: check types
  if (arguments.length === 1) {
    displayName = 'RockeyRecompose' + ++anonCounter;
    BaseComponent = arguments.length <= 0 ? undefined : arguments[0];
  } else {
    displayName = arguments.length <= 0 ? undefined : arguments[0];
    BaseComponent = arguments.length <= 1 ? undefined : arguments[1];
  }

  return function () {
    var RecomposeHoc = _compose2.default.apply(undefined, arguments)(BaseComponent);

    return (0, _2.default)(ucfirst(displayName), RecomposeHoc);
  };
};

var counter = {};

var _loop = function _loop(tag) {
  // ---- tag hoc lazy creation
  Object.defineProperty(RecomposeRockeyHoc, tag, {
    get: function get() {
      return function (displayName) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        var name = null;
        var enhancers = null;

        if ((0, _isString2.default)(displayName)) {
          name = ucfirst(displayName);
          enhancers = args;
        } else if ((0, _isFunction2.default)(displayName)) {
          if (!counter[tag]) {
            counter[tag] = 0;
          }

          name = 'RecomposeShortcut' + ucfirst(tag) + ++counter[tag];
          enhancers = [displayName].concat(args);
        } else {
          throw new Error('wrong usage');
        }

        var TagComponent = function TagComponent(props) {
          return _react2.default.createElement(tag, (0, _filterProps2.default)(props));
        };

        return RecomposeRockeyHoc(name, TagComponent).apply(undefined, _toConsumableArray(enhancers));
      };
    },
    set: function set() {
      throw new Error('Override default RockeyHoc shorcuts is disabled');
    }
  });
};

var _iteratorNormalCompletion = true;
var _didIteratorError = false;
var _iteratorError = undefined;

try {
  for (var _iterator = _htmlTags2.default[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
    var tag = _step.value;

    _loop(tag);
  }
} catch (err) {
  _didIteratorError = true;
  _iteratorError = err;
} finally {
  try {
    if (!_iteratorNormalCompletion && _iterator.return) {
      _iterator.return();
    }
  } finally {
    if (_didIteratorError) {
      throw _iteratorError;
    }
  }
}

exports.default = RecomposeRockeyHoc;